package holeg.power_flow;

public class PowerFlowProgram {
    public static void main(String[] args) {
        // Load data
        Bus[] buses = TestData.getIEEE14BussesHugeGeneration();
        Line[] lines = TestData.getIEEE14Lines();

        // Create problem and solver
        PowerFlowProblem problem = new PowerFlowProblem(buses, lines, 1, 1 / 100.0);
        Solver solver = new NewtonRaphsonSolver();

        // Solve the problem with default settings
        SolverResult result = solver.solve(problem, new SolverSettings());

        // Print result
        result.printTo(problem, System.out);
    }
}
